\section{\LARGE Examples \label{sec:examples}}

\subsection{\LARGE Fill and print event interpretations \label{sec:firstexample}}

\noindent
The easiest way of getting an event interpretation is a copy of the
reconstruction output of the experiment.\\
In the example below, we use L3 global muon reconstructor information
together with missing transverse energy.
In the method {\bf\red fillMuons}, the data from the {\bf\red
RecTrack} class is filled into {\bf\red PaxFourVector}'s with
name=``mu''. 
Relations to the original  {\bf\red TTrack} class instances are added for all
fourvectors.  \\
\\
In the method {\bf\red fillMissingEt}  the missing transverse energy
is calculated by looping over all {\bf\red  EcalPlusHcalTower}'s. The
sum of the transverse components of the energy is stored in the
{\bf\blue user record} of the event interpretation.\\
\\
All these objects are registered in the event 
interpretation ``reconstructed muons''. \\
\\
A similar procedure is implemented for generator data. The {\bf\red
fillGeneratedWdecay} method fills a simple decay tree for a $W$
decay. The decay vertex is taken care of and the correct
relations between fourvectors and vertices are established.\\ 
\\
These objects are then passed to {\bf\red
PaxDemoAnalysis::analyze} and printed.
\noindent
The printout you will get contains all the information which is 
available to the pax event interpretation
{\em (a few further comments are added below)}:\\
**************************************************************************\\
*  {\bf\blue PaxEventInterpret}::print\\
*  PaxId = 1  {\em (pax objects have a unique identifier PaxId),}$\;$
name = generated event\\
**************************************************************************\\
*******************************\\
PaxEventInterpret::print: {\bf\blue Vertices}   \\
*******************************\\
number of vertices= 2\\
=================================================\\
PaxId=8 name ={\bf\blue W decay vertex x=0.005 y=0.007 z=92.258} status =0 locked =0\\
...................................................................\\
{\bf\blue PaxVertexRelations}::print: total number of members=1 {\em (required for analysis history and the exclusion mechanism)}\\
PaxId=2 name =W decay vertex x=0.005 y=0.007 z=92.258 status =0 locked =0\\
...................................................................\\
{\bf\blue PaxOutgoingFourVectorRelations}::print:  total number of fourvectors=2 {\em (required for decay chains)}\\
PaxId=10 name =neutrino px=20.538 py=0.123 pz=74.734 e=77.505 charge=0.000 mass=0.027 id=14 status=0 simulated=0 workflag=0 locked=0\\
PaxId=7 name =mu px=-52.782 py=-90.036 pz=375.368 e=389.607
charge=1.000 mass=0.128 id=-13 status=0 simulated=0 workflag=0
locked=0\\
...................................................................\\
{\bf\blue PaxIncomingFourVectorRelations}::print:  total number of fourvectors=1\\
PaxId=4 name =W px=-32.244 py=-89.913 pz=450.103 e=467.112
charge=1.000 mass=80.483 id=24 status=0 simulated=0 workflag=0
locked=0\\
(.....)\\
\\
**********************************\\
PaxEventInterpret::print: {\bf\blue FourVectors}\\
**********************************\\
number of fourvectors= 3\\
=================================================\\
PaxId=10 name ={\bf\blue neutrino px=20.538 py=0.123 pz=74.734 e=77.505} charge=0.000 mass=0.027 id=14 status=0 simulated=0 workflag=0 locked=0\\
...................................................................\\
{\bf\blue PaxBeginVertexRelations}::print: total number of members=1 {\em (required for decay chains)}\\
PaxId=8 name =W decay vertex x=0.005 y=0.007 z=92.258 status =0 locked =0\\
...................................................................\\
{\bf\blue PaxFourVectorRelations}::print:  total number of fourvectors=1 {\em (required for analysis history and the exclusion mechanism)}\\
PaxId=10 name =neutrino px=20.538 py=0.123 pz=74.734 e=77.505 charge=0.000 mass=0.027 id=14 status=0 simulated=0 workflag=0 locked=0\\
...................................................................\\
ExperimentClassRelationsMap: {\bf\blue PaxExperimentClassRelations} name= const RawParticle {\em (enables access to the original CMS class member functions)}\\
PaxExperimentClassRelations::print:  total number of relations=1\\
related experimentclass key=12\\
(.....)\\

\noindent
If you prefer the kinematics in the form of (pt,eta,phi) instead of (px,py,pz) use the PAX printlevels
(section \ref{printlevel})\\
{\bf\red   eiParticles--$>$print(PAX$\_$PT);}\\
If the output is too elaborate for your taste try \\
{\bf\red   eiParticles--$>$print(PAX$\_$PTSHORT);}


\subsection{\LARGE Loop over PaxFourVectors, histogram their transverse momenta  }

\noindent
Here we sketch the begin-job, event loop, end-job structure,
to indicate the complete procedure to arrive at the histogram on disk.

\noindent
// ---------- begin job ----------- \\
// book histogram\\
{\bf\red   TH1F* fMuonPt = new TH1F("Muon: Pt","Muon: Pt", 20,1,100);}\\
\\
// ---------- during event processing ----------- \\
// get iterator for fourvectors from PaxEventInterpret instance  of
section \ref{sec:firstexample} \\ 
{\bf\red   PaxIterator$<$PaxFourVector* $>$* iter = eiParticles--$>$fourvector--$>$getIterator();}\\
\\
// loop over PaxFourVector instances and fill histogram\\
{\bf\red   for ( iter--$>$First(); !iter--$>$IsDone(); iter--$>$Next()  ) }\\
{\bf\red   \{ }\\
{\bf\red   double pt = iter--$>$CurrentItem()--$>$perp();}\\
{\bf\red   fMuonPt--$>$Fill( pt );}\\
{\bf\red   \} }\\
\\
// ---------- end job ----------- \\
// write histograms to file\\
{\bf\red   TFile f(filename.c\_str(), "recreate");}\\
{\bf\red   fMuonPt.Write();}\\
{\bf\red   f.Close();}\\
{\bf\red   delete fMuonPt;}\\



\subsection{\LARGE Loop over PaxVertex related PaxFourVector's  }

\noindent
Find the primary vertex and print the pseudo-rapidities of the 
fourvectors originating from the primary vertex.\\
\\
// get iterator for vertices from event interpret  of section \ref{sec:firstexample}\\
{\bf\red      PaxIterator$<$PaxVertex* $>$*  itervx = eiGenEvent--$>$vertex--$>$getIterator();}\\
\\
// loop over vertices \\
{\bf\red      for (itervx--$>$First(); !itervx--$>$IsDone(); itervx--$>$Next() )}\\
{\bf\red      \{ }\\
{\bf\red          cout $<<$ "name = " $<<$ iter\_vx--$>$CurrentItem()--$>$getPaxName()} \\
{\bf\red          (....)}\\
// get iterator for fourvectors via the outgoing fourvector relations\\
// of the vertices of event interpret\\
{\bf\red            PaxIterator$<$PaxFourVector* $>$* iterfv;}\\
{\bf\red iterfv = itervx--$>$CurrentItem()--$>$outgoing$\_$fourvector$\_$relations--$>$getIterator();}\\
\\
// loop and print information of fourvectors\\
{\bf\red            for ( iterfv--$>$First(); !iterfv--$>$IsDone(); iterfv--$>$Next() )}\\
{\bf\red   \{ }\\
{\bf\red            cout $<<$ "name = " $<<$iterfv--$>$CurrentItem()--$>$getPaxName() }\\
{\bf\red            $<<$ " pseudo-rapidity = " $<<$ iter\_fv--$>$CurrentItem()--$>$eta()$<<$endl;}\\ 
{\bf\red            (.....)}\\
{\bf\red          \}     \} }


\subsection{\LARGE Access original member function of CMS class  }

\noindent
Information needed from the  reconstruction output is 
best accessed within the interface functions to the experiment 
data (e.g. FillMuons, see section \ref{sec:firstexample}).
There the best knowledge should be passed to the 
event interpretations of PAX in terms of vertices, 
fourvectors, etc.
Nevertheless there is a way to recover the original 
pointer to the instance of a CMS detector class and access
its member function.
As an example we use the class TTrack below.\\
\\
// get iterator for fourvectors from event interpretation 
 of section \ref{sec:firstexample}\\ 
{\bf\red PaxIterator$<$PaxFourVector* $>$* iterfv = eiParticles--$>$fourvector--$>$getIterator(); } \\
// loop over all fourvectors\\
{\bf\red for (iterfv--$>$First(); !iterfv--$>$IsDone(); iterfv--$>$Next() ) } \\
{\bf\red      \{ } \\
// the name of the experiment class manager corresponds to the CMS class name\\
{\bf\red string experiment$\_$class$\_$manager="const TTrack"; } \\
\\
// check whether a relation manager has been registered with the name\\
// const TTrack \\
{\bf\red if ( iterfv--$>$CurrentItem()--$>$map$\_$experimentclass$\_$relations}\\
{\bf\red --$>$findItemByKey( experiment$\_$class$\_$manager )) } \\
{\bf\red  \{ } \\
// in general, many instances of TTrack may be related to a fourvector, e.g. in the case of jets.\\
// Get iterator for the experiment class from the relation manager \\
{\bf\red PaxIterator$<$PaxExperimentClass* $>$* iterec = iterfv--$>$CurrentItem()}\\
{\bf\red --$>$map$\_$experimentclass$\_$relations--$>$findItemByKey( experiment$\_$class$\_$manager )}\\
{\bf\red --$>$getIterator(); } \\
\\          
{\bf\red if ( !iterec--$>$IsDone() ) } \\
{\bf\red \{  } \\
// downcast from pax experiment class to detector class \\
{\bf\red PaxExperiment$<$const TTrack$>$* detector } \\
{\bf\red = dynamic$\_$cast$<$PaxExperiment$<$const TTrack$>$* $>$(iterec--$>$CurrentItem()); } \\
\\
// print the impact parameter etc, note that these are member functions\\
// of the class const TTrack\\
{\bf\red               cout  $<<$ " impact parameter = " $<<$ detector--$>$getData()--$>$impactParameter3D().value() } 
{\bf\red                (.....)}\\
{\bf\red      \}      \}      \} }

\subsection{\LARGE Reconstruct W bosons in leptonic decays}

\noindent
The example algorithm {\bf\blue PaxDemoAnalysis::MakeW}  reconstructs the decay chain 
W --$>$ lepton + neutrino from a W-mass constraint.
The algorithm uses on input an event interpretation, a lepton 
fourvector of this input event interpretation, missing 
transverse momentum components px, py, and a value for the 
W-boson mass.
\\
On output it delivers two event interpretations corresponding
to two solutions of the reconstructed W boson.
If the solutions are identical, only one event interpretation
is filled, the second remains empty.
On return, the number of W solutions is given.
\\
\noindent
// create two empty event interpretations for two possible W solutions\\
{\bf\red PaxEventInterpret* W1 = new PaxEventInterpret;}\\
{\bf\red PaxEventInterpret* W2 = new PaxEventInterpret;}\\
\\
// fill the two event interpretations, take px and py from\\
// reconstructed muon, W$\_$mass=80.42 GeV\\
{\bf\red int number\_of\_W = MakeW( eiParticles, W1, W2, muon, px, py, W$\_$mass );}\\
// print results\\
{\bf\red	  iter = W1--$>$fourvector--$>$getIterator();}\\
{\bf\red	  for ( iter--$>$First(); !iter--$>$IsDone(); iter--$>$Next() )}\\
{\bf\red	    \{}\\    
{\bf\red	      if ( iter--$>$CurrentItem()--$>$getPaxName() == "W" )}\\
{\bf\red		\{}\\
 // print the decay tree of the W boson\\
{\bf\red          iter--$>$CurrentItem()--$>$printDecayTree(PAX\_PTSHORT);  }\\
{\bf\red          \}     \} } \\
// clear memory\\
{\bf\red delete W1;}\\
{\bf\red delete W2;}\\

\subsection{\LARGE  Write event interpretations to file, read from file}

\noindent
// open file in write mode \\
{\bf\red PaxFile* OutFile = new PaxFile("PAXdataOutput.root",PaxFile::Write);}\\
// create new event interpretation \\
{\bf\red PaxEventInterpret* eiRecParticles = new PaxEventInterpret;}\\
// fill muons ..., then store event interpretation to file \\
{\bf\red eiRecParticles--$>$store(OutFile);}\\
// perhaps you want to store several event interpretations in the event...\\
// once the event is complete write the end-of-event marker\\
{\bf\red OutFile--$>$writeEvent();}\\
{\bf\red delete eiRecParticles;}\\
// ... write next event..., finally close and delete the event file\\
{\bf\red OutFile--$>$close();}\\
{\bf\red delete OutFile; }\\

\noindent
// open file in read mode \\
{\bf\red PaxFile* InFile = new PaxFile("PAXdataInput.root",PaxFile::Read);}\\
// read event into internal buffer, recover all relations between the \\
// event interpretations of this event \\
{\bf\red if (!InFile--$>$EndOfFile()) } \\
{\bf\red \{ } \\
{\bf\red InFile--$>$readEvent();}\\
// user access to first event interpretation (the file is now argument of the constructor!)\\
{\bf\red PaxEventInterpret* ei = new PaxEventInterpret(}{\bf\blue InFile}{\bf\red);}\\
// an empty event interpretation indicates the end-of-event \\
{\bf\red if (!ei--$>$IsEmpty()) ei--$>$print(); }\\
{\bf\red delete ei; }\\
{\bf\red \} }\\
// ...more events... finally close and delete event file \\
{\bf\red InFile--$>$close();}\\
{\bf\red delete InFile;}\\



%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "paxguide"
%%% End: 

% LocalWords:  endl FindItemByKey PaxExperimentClass iterec impactParameter ei
% LocalWords:  MakeW PrintDecayTree OutFile PAXdataOutput eiRecParticles InFile
% LocalWords:  PAXdataInput EndOfFile ReadEvent IsEmpty
